<?

function Compare($elem1, $elem2)
	{
	if($elem1>$elem2) return +1; elseif($elem1<$elem2) return -1; else return 0;
	}

function CompareArchers($archer1, $archer2)
	{
	$cat_ordre=array('B'=>1, 'M'=>2, 'C'=>3, 'J'=>4, 'S'=>5, 'V'=>6, 'U'=>7);
	
	$result=Compare($archer1['genre'], $archer2['genre']);
	if($result==0) $result=Compare($cat_ordre[$archer1['cat']], $cat_ordre[$archer2['cat']]);
	if($result==0) $result=Compare($archer1['arme'], $archer2['arme']);
	if($result==0) $result=-Compare($archer1['moyenne'], $archer2['moyenne']);
	if($result==0) $result=-Compare($archer1['score1'], $archer2['score1']);
	if($result==0) $result=-Compare($archer1['score2'], $archer2['score2']);
	if($result==0) $result=-Compare($archer1['score3'], $archer2['score3']);
	return $result;
	}
	
function CalculMoyennes(&$classement, $final=false)
	{
	reset($classement);
	foreach($classement as $id=>$archer) 
		{
		if($final) $nbScores=3;
		else
			{
			$nbScores=0;
			for($ct=1; $ct<=3; $ct++) if($archer['score'.$ct]>0) $nbScores++;
			}
		$classement[$id]['moyenne']=round(($archer['score1']+$archer['score2']+$archer['score3'])/$nbScores, 1);
		}
	}
	
function CalculPositions(&$classement)
	{
	reset($classement);
	$position=1;
	$tab=array();
	foreach($classement as $id=>$archer) 
		{
		$groupeActuel=array('cat'=>$archer['cat'], 'genre'=>$archer['genre'], 'arme'=>$archer['arme']);
		if(!isset($groupe) or $groupe!=$groupeActuel) 
			{
			$position=1;
			$groupe=$groupeActuel;
			}
		$classement[$id]['position']=$position++;
		}
	}

function ClassementTotal(&$classement, $classementFinal=false)
	{
	CalculMoyennes($classement, $classementFinal);
	usort($classement, 'CompareArchers');
	CalculPositions($classement);
	}
	
function ClassementQuotaPreselection(&$classement, $quotas)
	{
	foreach($classement as $id=>$archer) 
		{
		if($archer['position']<=$quotas[$archer['genre']][$archer['arme']][$archer['cat']][0])
			$classement[$id]['preselection']=1;
		else $classement[$id]['preselection']=0;
		}	
	}

function ClassementQuotaSelection(&$classement, $quotas, $souhait=false)
	{
	$groupe='';
	$nombre=0;
	foreach($classement as $id=>$archer) 
		{
		if($groupe!=$archer['genre'].$archer['arme'].$archer['cat'])
			{
			$nombre=$quotas[$archer['genre']][$archer['arme']][$archer['cat']][1];
			$groupe=$archer['genre'].$archer['arme'].$archer['cat'];
			}
		if($nombre>0 and $archer['preselection']==1 and ($souhait==false or $archer['souhait']==1)) 
			{
			$classement[$id]['selection']=1; 
			$nombre--;
			}
		else $classement[$id]['selection']=0;
		}
	}
	
function ClassementQuotaSelectionAvecSouhait(&$classement, $quotas)
	{
	ClassementQuotaSelection($classement, $quotas, true);
	}
	
function FiltreCategories(&$classement, $categories)
	{
	foreach($classement as $id=>$ligne)
		if(!in_array($ligne['cat'], $categories)) unset($classement[$id]);
	}
	
function CompareTableaux($tab1, $tab2)
	{
	return serialize($tab1)==serialize($tab2);
	}
	
function CompareLigneParChamps($ligne1, $ligne2, $champs)
	{
	reset($champs);
	foreach($champs as $chp) 
		if(!isset($ligne1[$chp]) or !isset($ligne2[$chp])) return false;
		elseif($ligne1[$chp]!=$ligne2[$chp]) return false;
	return true;
	}
	
function ChercheLigne($classement, $champsClef, $ligne)
	{
	reset($classement);
	foreach($classement as $source) if(CompareLigneParChamps($source, $ligne, $champsClef)) return $source;
	return array();
	}
	
function CopieChampsEntreTab($emetteur, &$recepteur, $champsCopie=array())
	{
	reset($emetteur);
	foreach($emetteur as $nomInfo=>$info)
		{
		$copie=false;
		if(empty($champsCopie)) $copie=true; elseif(isset($champsCopie[$nomInfo])) $copie=true;
		if($copie==true) $recepteur[$nomInfo]=$info;
		}
	}
	
function CreationChampsVides(&$recepteur, $champs)
	{
	CopieChampsEntreTab($champs, $recepteur);
	}
	
function VerifieUniciteClef($classement, $champsClef, &$idLigne)
	{
	$idLigne=0;
	if(!is_array($champsClef)) $champsClef=array($champsClef);
	$tab=array();
	reset($classement);
	foreach($classement as $id=>$ligne) if(ChercheLigne($tab, $champsClef, $ligne)==array()) $tab[]=$ligne; else 
		{
		$idLigne=$id;
		return false;
		}
	return true;
	}

function Integration(&$classement, $tab, $champsClef, $champsCopie=array())
	{
	$lignesTraitees=0;

	if(!is_array($champsClef)) $champsClef=array($champsClef);
	reset($classement);
	foreach($classement as $id=>$maitre)
		{
		$source=ChercheLigne($tab, $champsClef, $maitre);
		if(!empty($source))
			{
			CopieChampsEntreTab($source, $classement[$id], $champsCopie);
			$lignesTraitees++;
			}
		elseif(!empty($champsCopie)) CreationChampsVides($classement[$id], $champsCopie); 
		}

	return $lignesTraitees++;
	}
	
function ClassementHTML_Groupes(&$tpl, &$groupe, $ligne, $champs)
	{
	$categories=array('B'=>'Benjamins', 'M'=>'Minimes', 'C'=>'Cadets', 'J'=>'Juniors', 'S'=>'Seniors', 'V'=>'Vtrans', 'U'=>'SuperVtrans');
	$sexes=array('F'=>'Femmes', 'H'=>'Hommes');
	$armes=array('CL'=>'Classique', 'CO'=>'Poulies');

	if($groupe!='')
		{
		reset($champs);
		foreach($champs as $ident=>$titre)
			{
			$tpl->assign('TITRE', $titre);
			$tpl->parse('MAIN.GROUPE.TITRE');
			}
		if(!isset($categories[substr($groupe, 0, 1)])) echo "categorie inconnue ".substr($groupe, 0, 1).'<br>';
		if(!isset($sexes[substr($groupe, 1, 1)])) echo "sexe inconnue ".substr($groupe, 1, 1).'<br>';
		if(!isset($armes[substr($groupe, 2, 2)])) echo "arme inconnue ".substr($groupe, 2, 2).'<br>';
		$tpl->assign('GROUPE', $categories[substr($groupe, 0, 1)].'&nbsp;'.$sexes[substr($groupe, 1, 1)].'&nbsp;'.$armes[substr($groupe, 2, 2)]);
		$tpl->assign('NBCOLONNES', count($champs));
		$tpl->parse('MAIN.GROUPE');
		}
	$groupe=$ligne['cat'].$ligne['genre'].$ligne['arme'];
	echo "groupe $groupe<br>";
	}
	
function FormateDonnees($ident, $valeur)
	{
	$ouinon=array(0=>'non', 1=>'oui');
	$souhait=array(0=>'', 1=>'present', 2=>'absent');
	
	switch($ident)
		{
		case 'souhait' : return $souhait[$valeur]; break;
		case 'selection' : 
		case 'preselection' : return $ouinon[$valeur]; break;
		default: return $valeur;
		}
	}
	
function RecupereValeur($ident, $ligne)
	{
	$champs=explode('+', $ident);
	$result=array();
	foreach($champs as $chp) $result[]=$ligne[$chp];
	return implode(' ', $result);
	}
	
function ClassementHTML($classement, $champs)
	{
	include_once('code/xtemplate.lib.php');
	
	$tpl=new XTemplate('code/classement.tpl');
	
	$groupe='';
	$ligneNum=0;
	reset($classement);
	foreach($classement as $ligne)
		{
		if($groupe!=$ligne['cat'].$ligne['genre'].$ligne['arme']) ClassementHTML_Groupes($tpl, $groupe, $ligne, $champs);
		
		reset($champs);
		foreach($champs as $ident=>$titre)
			{
			$tpl->assign('VALEUR', FormateDonnees($ident, RecupereValeur($ident, $ligne)));
			$tpl->parse('MAIN.GROUPE.LIGNE.VALEUR');
			}
		
		if($ligne['preselection']==1) $tpl->assign('NUM', ($ligneNum+3).'');
		else $tpl->assign('NUM', ($ligneNum+1).'');
		$tpl->parse('MAIN.GROUPE.LIGNE');
		$ligneNum=!$ligneNum;
		}
	ClassementHTML_Groupes($tpl, $groupe, $ligne, $champs);
	$tpl->assign('DATE', date('d M Y  H:i:s', time()));
	$tpl->parse('MAIN');
	return $tpl->text('MAIN');
	}

//if(isset($_SERVER['LS_COLORS'])) 
define('CHEMIN_XLHTML', '/usr/bin/xlhtml');
//else 
//define('CHEMIN_XLHTML', 'C:\\http\\Archives\\synchroweb\\bin\\xlhtml.exe');

function SimplifieHtmlExcel($chaine)
	{
  $supprime=array('<FONT FACE="&nbsp;">', '&nbsp;', '<br>', 'ALIGN="center"', ' VALIGN="bottom"', '<FONT FACE="Arial">', '<TABLE BORDER="1" CELLSPACING="2">', "\n", "\r", '</B>', '<B>', '</FONT>', '<TD>', '<TR>', '<TR >');
  $chaine=str_replace($supprime, '', $chaine);
  $chaine=str_replace('</TD>', '$', $chaine);
  $chaine=str_replace('Licence$Nom$Prnom$Catgorie$Catgorie Surcl$Sexe$Arme$Niveau$Club$Agrment$Score$Paille$Dix$Neuf$Distance$Blason$Date$Lieu$Organisateur$Champ.$Distinction$Place Qualif.$Score Dist. 1$Score Dist. 2$Score Dist. 3$Score Dist. 4$Place Def.$Nb Tir$</TR>', '', $chaine);
  $chaine=preg_replace('|<H1><CENTER>[a-zA-Z0-9 .]+</CENTER></H1>|', '', $chaine);
  //$chaine=preg_replace('|</table><HR><H1><CENTER>Rsultats [0-9]+ de L  Z</CENTER></H1><br>|', '', $chaine);
  $chaine=preg_replace('|</table>.+<br>|', '', $chaine);
	$tab=explode('</TR>', $chaine);
	unset($tab[count($tab)-1]);
	unset($tab[0]);
	return $tab;
	}

function DecodeExcel($fichier)
	{
  exec(CHEMIN_XLHTML.' -nh '.$fichier, $reponse, $etat);
	return SimplifieHtmlExcel(implode('', $reponse));
	}

function ChargerClassementFFTA(&$classement, $fichier)
	{
	if(!file_exists($fichier)) die("fatal : fichier $fichier n'existe pas");
	$tab=DecodeExcel($fichier);
	
	foreach($tab as $ligne)
		{
		$ligne=explode('$', $ligne);
		$classement[]=array(
			'france'=>$ligne[0],
			'position'=>$ligne[1],
			'licence'=>$ligne[4], 
			'nom'=>$ligne[5], 
			'prenom'=>$ligne[6],
			'adresse'=>$ligne[7],
			'complement'=>$ligne[8],
			'cp'=>$ligne[9],
			'ville'=>$ligne[10],
			'cat'=>$ligne[11],
			'genre'=>$ligne[12],
			'arme'=>$ligne[13],
			'agreement'=>$ligne[14],
			'club'=>$ligne[15],
			'score1'=>$ligne[16], 
			'score2'=>$ligne[17], 
			'score3'=>$ligne[18], 
			'moyenne'=>$ligne[19]);
		}
	}
	
function ChargerFichierCSV(&$classement, $fichier, $champs, $separateur=';')
	{
	if(!file_exists($fichier)) die("fatal : fichier $fichier n'existe pas");

	$tab=file($fichier);
	foreach($tab as $ligne)
		{
		$ligne=str_replace("\r", '', str_replace("\n", '', $ligne));
		$ligne=explode($separateur, $ligne);
		reset($champs);
		foreach($champs as $id=>$chp) $c[$chp]=$ligne[$id];
		$classement[]=$c;
		}
	}

function PresenceChamps($classement, $champs, &$reponses)
	{
	$reponses=array();
	reset($classement);
	foreach($classement as $id=>$ligne)
		{
		$manque=array();
		reset($champs);
		foreach($champs as $chp) if(!isset($ligne[$chp])) $manque[]=$chp; 
		if(!empty($manque)) $reponses[]=array('id'=>$id, 'manque'=>$manque);
		}
	return empty($reponses);
	}
	
function OrdonneTableau(&$tableau, $champs)
	{
	$nvx=array();
	reset($champs);
	foreach($champs as $chp) $nvx[$chp]=$tableau[$chp];
	$tableau=$nvx;
	}
	
function OrdonneChamps(&$classement, $champs)
	{
	reset($classement);
	foreach($classement as $id=>$ligne) OrdonneTableau($classement[$id], $champs);
	}
	
function ExportVersRat($classement, &$reponses)
	{
	$champs=array('licence', 'position', 'france', 'cat', 'genre', 'arme', 'prenom', 'nom', 'agreement', 'club', 'score1', 'score2', 'score3', 'moyenne');
	//if(!PresenceChamps($classement, $champs, $reponses)) return false;
	
	$result='';
	OrdonneChamps($classement, $champs);
	reset($classement);
	foreach($classement as $ligne) 
		{
		OrdonneTableau($ligne, $champs);
		$result[]=implode('$', $ligne);
		}
	return implode("\r\n", $result);
	}
	
// tester et valider
function FiltreChamp(&$classement, $champ, $valeur)
	{
	foreach($classement as $id=>$ligne)
		if($ligne[$champ]!=$valeur) unset($classement[$id]);
	}
	
function ClassementCSV($classement, $champs, $separateur=';')
	{
	$result=implode($separateur, $champs)."\r\n";
	foreach($classement as $ligne) 
		{
		$aff=array();
		reset($champs);
		foreach($champs as $chp=>$valeur) $aff[]=$ligne[$chp];
		$result.=implode($separateur, $aff)."\r\n";
		}
	return $result;
	}
	
function Sauver($fichier, $valeur)
	{
	$f=fopen($fichier, 'w');
	fwrite($f, $valeur);
	fclose($f);
	}

function CorrectionCategories(&$classement)
	{
	reset($classement);
	foreach($classement as $id=>$ligne) 
		{
		if(in_array($ligne['cat'], array('C', 'M', 'B')) and $ligne['arme']=='CO') $classement[$id]['cat']='J';
		if($ligne['cat']=='SV') $classement[$id]['cat']='U';
		}
	}
	
?>
