<?php

class TestClassement_UneCat extends CClassement_Abstrait 
	{
  function TestClassement_UneCat() 
		{
    $this->UnitTestCase();
    }
		
	function setUp()
		{
		$this->classement=array(
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>546, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>577, 'score2'=>576, 'score3'=>575, 'moyenne'=>576, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>567, 'score2'=>566, 'score3'=>565, 'moyenne'=>566, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>507, 'score2'=>506, 'score3'=>0, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));
		}
		
	function VerifieClassement($index, $position, $licence, $prenom, $moyenne)
		{
		$this->AssertEqual($position, $this->classement[$index]['position']);
		$this->AssertEqual($licence, $this->classement[$index]['licence']);
		$this->AssertEqual($prenom, $this->classement[$index]['prenom']);
		$this->AssertEqual($moyenne, $this->classement[$index]['moyenne']);
		}
		
	function testClassementExAequoSurLaMoyenne()
		{
		$this->classement=array(
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>550, 'score2'=>550, 'score3'=>550, 'moyenne'=>546, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>551, 'score2'=>550, 'score3'=>550, 'moyenne'=>576, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));

		ClassementTotal($this->classement, true);
		
		$this->VerifieClassement(0, 1, 'A', 'cedric', 550.3);
		$this->VerifieClassement(1, 2, 'C', 'bertrand', 550);
		}
		
	function testClassementIntermediaire_UneCategorie()
		{
		ClassementTotal($this->classement, false);
		
		$this->VerifieClassement(0, 1, 'A', 'cedric', 576);
		$this->VerifieClassement(1, 2, 'B', 'gaston', 566);
		$this->VerifieClassement(2, 3, 'C', 'bertrand', 556);
		$this->VerifieClassement(3, 4, 'D', 'jules', 506.5);
		}
		
	function testClassementFinal()
		{
		ClassementTotal($this->classement, true);
		
		$this->VerifieClassement(0, 1, 'A', 'cedric', 576);
		$this->VerifieClassement(1, 2, 'B', 'gaston', 566);
		$this->VerifieClassement(2, 3, 'C', 'bertrand', 556);
		$this->VerifieClassement(3, 4, 'D', 'jules', 337.7);
		}

	function testCompareMoyennesDifferentes()
		{
		$this->assertEqual(0, CompareArchers($this->classement[0], $this->classement[0]));
		$this->assertEqual(+1, CompareArchers($this->classement[0], $this->classement[1]));
		$this->assertEqual(+1, CompareArchers($this->classement[0], $this->classement[2]));
		$this->assertEqual(-1, CompareArchers($this->classement[1], $this->classement[2]));
		}
		
	function testCompareScores()
		{
		$this->assertEqual(0, Compare(576, 576));
		$this->assertEqual(+1, Compare(576, 556));
		$this->assertEqual(+1, Compare(576, 566));
		$this->assertEqual(+1, Compare(566, 556));
		
		$tab=array(556, 576, 566);
		usort($tab, 'Compare');
		$this->assertEqual(556, $tab[0]);
		$this->assertEqual(566, $tab[1]);
		$this->assertEqual(576, $tab[2]);
		}
	}
	
class TestClassement_DesCats extends CClassement_Abstrait 
	{
  function TestClassement_DesCats() 
		{
    $this->UnitTestCase();
    }
		
	function setUp()
		{
		$this->classement=ArchersBeaucoup();
			}
		
	function VerifieClassement($index, $position, $licence, $prenom, $moyenne, $cat, $genre, $arme)
		{
		//$this->AssertEqual($licence, $this->classement[$index]['licence']);
		//*
		$tab=array('position', 'licence', 'prenom', 'moyenne', 'cat', 'genre', 'arme');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ]);
		//*/
		}

	function testCompareMoyennesDifferentes()
		{
		$this->assertEqual(0, CompareArchers($this->classement[0], $this->classement[0]));
		$this->assertEqual(+1, CompareArchers($this->classement[0], $this->classement[1]));
		$this->assertEqual(-1, CompareArchers($this->classement[6], $this->classement[5]));
		}
		
	function testClassementIntermediaire()
		{
		ClassementTotal($this->classement, false);
		
		$ct=0;
		
		$this->VerifieClassement($ct++, 1, 'F', 'yoko', 545, 'S', 'F', 'CL');
		$this->VerifieClassement($ct++, 2, 'E', 'cameron', 535, 'S', 'F', 'CL');
		
		$this->VerifieClassement($ct++, 1, 'G', 'fifi', 410, 'M', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'H', 'riri', 400, 'M', 'H', 'CL');
		$this->VerifieClassement($ct++, 3, 'I', 'loulou', 390, 'M', 'H', 'CL');		

		$this->VerifieClassement($ct++, 1, 'J', 'laurel', 500, 'J', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'K', 'hardi', 490, 'J', 'H', 'CL');		
		
		$this->VerifieClassement($ct++, 1, 'L', 'dartagnan', 604, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 2, 'M', 'aramis', 403, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 3, 'N', 'portos', 402, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 4, 'O', 'athos', 401, 'J', 'H', 'CO');		

		$this->VerifieClassement($ct++, 1, 'A', 'cedric', 576, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'B', 'gaston', 566, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 3, 'C', 'bertrand', 556, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 4, 'D', 'jules', 506.5, 'S', 'H', 'CL');
		}
		
	function testClassementFinal()
		{
		ClassementTotal($this->classement, true);

		$ct=0;

		$this->VerifieClassement($ct++, 1, 'E', 'cameron', 535, 'S', 'F', 'CL');
		$this->VerifieClassement($ct++, 2, 'F', 'yoko', 363.3, 'S', 'F', 'CL');
		
		$this->VerifieClassement($ct++, 1, 'G', 'fifi', 410, 'M', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'H', 'riri', 400, 'M', 'H', 'CL');
		
		$this->VerifieClassement($ct++, 3, 'I', 'loulou', 390, 'M', 'H', 'CL');		
		$this->VerifieClassement($ct++, 1, 'J', 'laurel', 500, 'J', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'K', 'hardi', 490, 'J', 'H', 'CL');		
		
		$this->VerifieClassement($ct++, 1, 'L', 'dartagnan', 604, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 2, 'M', 'aramis', 403, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 3, 'N', 'portos', 402, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 4, 'O', 'athos', 401, 'J', 'H', 'CO');		

		$this->VerifieClassement($ct++, 1, 'A', 'cedric', 576, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'B', 'gaston', 566, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 3, 'C', 'bertrand', 556, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 4, 'D', 'jules', 337.7, 'S', 'H', 'CL');
		}
	}

class TestClassement_Egalites extends CClassement_Abstrait 
	{
  function TestClassement_Egalites() 
		{
    $this->UnitTestCase();
    }
		
	function setUp()
		{
		$this->classement=array(
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>555, 'score2'=>550, 'score3'=>545, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>551, 'score2'=>549, 'score3'=>549, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>560, 'score2'=>550, 'score3'=>540, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>551, 'score2'=>550, 'score3'=>549, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));
			}
		
	function VerifieClassement($index, $position, $licence, $prenom, $moyenne, $cat, $genre, $arme)
		{
		//$this->AssertEqual($licence, $this->classement[$index]['licence']);
		//*
		$tab=array('position', 'licence', 'prenom', 'moyenne', 'cat', 'genre', 'arme');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ]);
		//*/
		}

	function testClassementIntermediaire()
		{
		ClassementTotal($this->classement, false);
		
		$ct=0;
		
		$this->VerifieClassement($ct++, 1, 'A', 'cedric', 550, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'C', 'bertrand', 550, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 3, 'D', 'jules', 550, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 4, 'B', 'gaston', 549.7, 'S', 'H', 'CL');
		}
		
	function ztestClassementFinal()
		{
		ClassementTotal($this->classement, true);

		$ct=0;

		$this->VerifieClassement($ct++, 1, 'E', 'cameron', 535, 'S', 'F', 'CL');
		$this->VerifieClassement($ct++, 2, 'F', 'yoko', 363, 'S', 'F', 'CL');
		
		$this->VerifieClassement($ct++, 1, 'G', 'fifi', 410, 'M', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'H', 'riri', 400, 'M', 'H', 'CL');		
		$this->VerifieClassement($ct++, 3, 'I', 'loulou', 390, 'M', 'H', 'CL');
				
		$this->VerifieClassement($ct++, 1, 'J', 'laurel', 500, 'J', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'K', 'hardi', 490, 'J', 'H', 'CL');		
		
		$this->VerifieClassement($ct++, 1, 'L', 'dartagnan', 604, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 2, 'M', 'aramis', 403, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 3, 'N', 'portos', 402, 'J', 'H', 'CO');		
		$this->VerifieClassement($ct++, 4, 'O', 'athos', 401, 'J', 'H', 'CO');		

		$this->VerifieClassement($ct++, 1, 'A', 'cedric', 576, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 2, 'B', 'gaston', 566, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 3, 'C', 'bertrand', 556, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 4, 'D', 'jules', 338, 'S', 'H', 'CL');
		}
	}
	
class TestClassement_Quotas extends CClassement_Abstrait 
	{
  function TestClassement_Quotas() 
		{
    $this->UnitTestCase();
    }
		
	function setUp()
		{
		$this->classement=array(
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>577, 'score2'=>576, 'score3'=>575, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>507, 'score2'=>506, 'score3'=>0, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>567, 'score2'=>566, 'score3'=>565, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			
			array('licence'=>'F', 'nom'=>'tsuno', 'prenom'=>'yoko', 'score1'=>550, 'score2'=>540, 'score3'=>0, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'F', 'cat'=>'S'),
			array('licence'=>'E', 'nom'=>'diaz', 'prenom'=>'cameron', 'score1'=>545, 'score2'=>535, 'score3'=>525, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'F', 'cat'=>'S'),

			array('licence'=>'H', 'nom'=>'disney', 'prenom'=>'riri', 'score1'=>400, 'score2'=>400, 'score3'=>400, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'M'),
			array('licence'=>'G', 'nom'=>'disney', 'prenom'=>'fifi', 'score1'=>410, 'score2'=>410, 'score3'=>410, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'M'),
			array('licence'=>'I', 'nom'=>'disney', 'prenom'=>'loulou', 'score1'=>390, 'score2'=>390, 'score3'=>390, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'M'),

			array('licence'=>'J', 'nom'=>'n&b', 'prenom'=>'laurel', 'score1'=>500, 'score2'=>500, 'score3'=>500, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'M'),
			array('licence'=>'K', 'nom'=>'n&b', 'prenom'=>'hardi', 'score1'=>490, 'score2'=>490, 'score3'=>490, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'M'),

			array('licence'=>'O', 'nom'=>'dumas', 'prenom'=>'athos', 'score1'=>401, 'score2'=>401, 'score3'=>401, 'moyenne'=>0, 'arme'=>'CO', 'genre'=>'H', 'cat'=>'J'),
			array('licence'=>'N', 'nom'=>'dumas', 'prenom'=>'portos', 'score1'=>402, 'score2'=>402, 'score3'=>402, 'moyenne'=>0, 'arme'=>'CO', 'genre'=>'H', 'cat'=>'J'),
			array('licence'=>'M', 'nom'=>'dumas', 'prenom'=>'aramis', 'score1'=>403, 'score2'=>403, 'score3'=>403, 'moyenne'=>0, 'arme'=>'CO', 'genre'=>'H', 'cat'=>'J'),
			array('licence'=>'L', 'nom'=>'dumas', 'prenom'=>'dartagnan', 'score1'=>604, 'score2'=>604, 'score3'=>604, 'moyenne'=>0, 'arme'=>'CO', 'genre'=>'H', 'cat'=>'J'));
			
		$this->quotas=array(
			'F'=>array('CL'=>array('S'=>array(4, 1))),
			'H'=>array('CL'=>array('S'=>array(4, 2), 'M'=>array(4, 3)), 'CO'=>array('J'=>array(4, 2)))
			);
		}
	
	function VerifieClassement($index, $position, $licence, $prenom, $cat, $genre, $arme, $preselection, $selection, $texte='')
		{
		//$this->AssertEqual($licence, $this->classement[$index]['licence']);
		//*
		$tab=array('position', 'licence', 'prenom', 'cat', 'genre', 'arme', 'preselection', 'selection');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ], $champ.' '.$texte);
		//*/
		}

	function testQuotasSelection()
		{			
		ClassementTotal($this->classement, true);
		ClassementQuotaPreselection($this->classement, $this->quotas);
		ClassementQuotaSelection($this->classement, $this->quotas);
		
		$ct=0;

		$this->VerifieClassement($ct, 1, 'E', 'cameron', 'S', 'F', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 2, 'F', 'yoko', 'S', 'F', 'CL', 1,  0, $ct++);
		
		$this->VerifieClassement($ct, 1, 'J', 'laurel', 'M', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 2, 'K', 'hardi', 'M', 'H', 'CL', 1,  1, $ct++);		
		$this->VerifieClassement($ct, 3, 'G', 'fifi', 'M', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 4, 'H', 'riri', 'M', 'H', 'CL', 1,  0, $ct++);
		$this->VerifieClassement($ct, 5, 'I', 'loulou', 'M', 'H', 'CL', 0,  0, $ct++);		
		
		$this->VerifieClassement($ct, 1, 'L', 'dartagnan', 'J', 'H', 'CO', 1,  1, $ct++);		
		$this->VerifieClassement($ct, 2, 'M', 'aramis', 'J', 'H', 'CO', 1,  1, $ct++);		
		$this->VerifieClassement($ct, 3, 'N', 'portos', 'J', 'H', 'CO', 1,  0, $ct++);		
		$this->VerifieClassement($ct, 4, 'O', 'athos', 'J', 'H', 'CO', 1,  0, $ct++);		

		$this->VerifieClassement($ct, 1, 'A', 'cedric', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 2, 'B', 'gaston', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 3, 'C', 'bertrand', 'S', 'H', 'CL', 1,  0, $ct++);
		$this->VerifieClassement($ct, 4, 'D', 'jules', 'S', 'H', 'CL', 1,  0, $ct++);
		}

	function testQuotasSelection_PreselectionObligatoire()
		{			
		$this->classement=array(
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>577, 'score2'=>576, 'score3'=>575, 'moyenne'=>0, 'preselection'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>507, 'score2'=>506, 'score3'=>0, 'moyenne'=>0, 'preselection'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'preselection'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>567, 'score2'=>566, 'score3'=>565, 'moyenne'=>0, 'preselection'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));
			
		ClassementTotal($this->classement, true);
		ClassementQuotaSelection($this->classement, $this->quotas);
		
		$ct=0;

		$this->VerifieClassement($ct, 1, 'A', 'cedric', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 2, 'B', 'gaston', 'S', 'H', 'CL', 0,  0, $ct++);
		$this->VerifieClassement($ct, 3, 'C', 'bertrand', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 4, 'D', 'jules', 'S', 'H', 'CL', 1,  0, $ct++);
		}

	function testQuotasSelection_SouhaitPrisEnCompte()
		{			
		$this->classement=array(
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>577, 'score2'=>576, 'score3'=>575, 'moyenne'=>0, 'preselection'=>1, 'souhait'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>507, 'score2'=>506, 'score3'=>0, 'moyenne'=>0, 'preselection'=>1, 'souhait'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'preselection'=>1, 'souhait'=>1, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>567, 'score2'=>566, 'score3'=>565, 'moyenne'=>0, 'preselection'=>1, 'souhait'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));
			
		ClassementTotal($this->classement, true);
		ClassementQuotaSelectionAvecSouhait($this->classement, $this->quotas);
		
		$ct=0;

		$this->VerifieClassement($ct, 1, 'A', 'cedric', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 2, 'B', 'gaston', 'S', 'H', 'CL', 1,  0, $ct++);
		$this->VerifieClassement($ct, 3, 'C', 'bertrand', 'S', 'H', 'CL', 1,  1, $ct++);
		$this->VerifieClassement($ct, 4, 'D', 'jules', 'S', 'H', 'CL', 1,  0, $ct++);
		}

	}
	
?>