<?
	
class TestClassement_Integrations extends CClassement_Abstrait 
	{
  function TestClassement_Integrations() 
		{
    $this->CClassement_Abstrait();
    }
		
	function VerifieClassement($index, $licence, $prenom, $score1, $score2, $score3, $moyenne, $cat, $genre, $arme)
		{
		$tab=array('licence', 'prenom', 'score1', 'score2', 'score3', 'moyenne', 'cat', 'genre', 'arme');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ]);
		}

	function VerifieClassement2($index, $licence, $preinscrit)
		{
		$tab=array('licence', 'preinscrit');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ]);
		}

	function VerifieClassement3($index, $licence, $souhait)
		{
		$tab=array('licence', 'souhait');
		foreach($tab as $champ)
			$this->AssertEqual($$champ, $this->classement[$index][$champ]);
		}

	function setUp()
		{
		$this->classement=array(
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>577, 'score2'=>576, 'score3'=>575, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>567, 'score2'=>566, 'score3'=>565, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>507, 'score2'=>506, 'score3'=>0, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S'));
		}
		
	function testMajScoresViaLicence()
		{
		$tab=array(
			array('licence'=>'C', 'score1'=>557, 'score2'=>556, 'score3'=>555),
			array('licence'=>'A', 'score1'=>583, 'score2'=>577, 'score3'=>576),
			array('licence'=>'B', 'score1'=>577, 'score2'=>567, 'score3'=>566),
			array('licence'=>'F', 'score1'=>500, 'score2'=>500, 'score3'=>500));

		$this->assertEqual(3, Integration($this->classement, $tab, 'licence'));
		
		$this->assertEqual(4, count($this->classement));
		$ct=0;
		$this->VerifieClassement($ct++, 'C', 'bertrand', 557,556,555, 0, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 'A', 'cedric', 583,577,576, 0, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 'B', 'gaston', 577,567,566, 0, 'S', 'H', 'CL');
		$this->VerifieClassement($ct++, 'D', 'jules', 507,506,0, 0, 'S', 'H', 'CL');
		}
		
	function testAjouteInfoPourCertains()
		{
		$tab=array(
			array('licence'=>'C', 'preinscrit'=>1),
			array('licence'=>'A', 'preinscrit'=>0),
			array('licence'=>'B', 'preinscrit'=>1),
			array('licence'=>'F', 'preinscrit'=>1));

		$this->assertEqual(3, Integration($this->classement, $tab, 'licence', array('preinscrit'=>2)));
		$ct=0;
		$this->VerifieClassement2($ct++, 'C', 1);
		$this->VerifieClassement2($ct++, 'A', 0);
		$this->VerifieClassement2($ct++, 'B', 1);
		$this->VerifieClassement2($ct++, 'D', 2);
		}
		
	function testCopieSouhaitParticipationParNomPrenom()
		{
		$tab=array(
			array('nom'=>'labvue', 'prenom'=>'bertrand', 'souhait'=>'0'),
			array('nom'=>'girard', 'prenom'=>'cedric', 'souhait'=>'1'),
			array('nom'=>'lagaffe', 'prenom'=>'gaston', 'souhait'=>'1'));

		$this->assertEqual(3, Integration($this->classement, $tab, array('nom', 'prenom'), array('souhait'=>2)));
		$ct=0;
		$this->VerifieClassement3($ct++, 'C', 0);
		$this->VerifieClassement3($ct++, 'A', 1);
		$this->VerifieClassement3($ct++, 'B', 1);
		$this->VerifieClassement3($ct++, 'D', 2);
		}
		
	function testChercheLigne()
		{
		$this->assertEqual($this->classement[0], ChercheLigne($this->classement, array('prenom', 'nom'), array('prenom'=>'bertrand', 'nom'=>'labvue')));
		$this->assertEqual($this->classement[1], ChercheLigne($this->classement, array('prenom', 'nom'), array('prenom'=>'cedric', 'nom'=>'girard')));
		$this->assertEqual($this->classement[2], ChercheLigne($this->classement, array('prenom', 'nom'), array('prenom'=>'gaston', 'nom'=>'lagaffe')));
		$this->assertEqual($this->classement[3], ChercheLigne($this->classement, array('prenom', 'nom'), array('prenom'=>'jules', 'nom'=>'dechezsmith')));
		}
		
	function testVerifieUniciteClef()
		{
		$idDoublon=0;
		$this->assertEqual(true, VerifieUniciteClef($this->classement, 'licence', $idDoublon));
		$this->assertEqual(0, $idDoublon);
		$this->assertEqual(true, VerifieUniciteClef($this->classement, array('nom', 'prenom'), $idDoublon));
		$this->assertEqual(0, $idDoublon);
		$this->assertEqual(false, VerifieUniciteClef($this->classement, array('moyenne'), $idDoublon));
		$this->assertEqual(1, $idDoublon);
		$this->assertEqual(true, VerifieUniciteClef($this->classement, array('moyenne', 'prenom'), $idDoublon));
		$this->assertEqual(0, $idDoublon);
		}
		
	}
	
?>