<?

class TestClassement_Manipulations extends CClassement_Abstrait 
	{
  function TestClassement_Manipulations() 
		{
    $this->CClassement_Abstrait();
    }
		
	function setUp()
		{
		$this->classement=ArchersBeaucoup();
		}
		
	function testEgalALuiMeme()
		{
		$this->assertEqual(true, CompareTableaux($this->classement, $this->classement));
		}
		
	function testCopieEtEgaux()
		{
		$tab=$this->classement;
		$this->assertEqual(true, CompareTableaux($tab, $this->classement));
		unset($tab[0]);
		$this->assertEqual(false, CompareTableaux($tab, $this->classement));
		}

	function testPresenceChamps()
		{
		$tab1=array(
			array('licence'=>'A', 'prenom'=>'cedric', 'moyenne'=>590), 
			array('licence'=>'A', 'prenom'=>'cedric', 'moyenne'=>590), 
			array('licence'=>'A', 'prenom'=>'cedric', 'moyenne'=>590));
		$tab2=array(
			array('licence'=>'A', 'prenom'=>'cedric', 'moyenne'=>590), 
			array('licence'=>'A', 'prenom'=>'cedric'), 
			array('prenom'=>'cedric', 'moyenne'=>590), 
			array('moyenne'=>590));
			
		$reponses=array();
		$this->assertEqual(true, PresenceChamps($tab1, array('licence', 'prenom', 'moyenne'), $reponses));
		$this->assertEqual(0, count($reponses));
		$this->assertEqual(false, PresenceChamps($tab2, array('licence', 'prenom', 'moyenne'), $reponses));
		$this->assertEqual(3, count($reponses));
		$this->assertEqual(array('id'=>1, 'manque'=>array('moyenne')), $reponses[0]);
		$this->assertEqual(array('id'=>2, 'manque'=>array('licence')), $reponses[1]);
		$this->assertEqual(array('id'=>3, 'manque'=>array('licence', 'prenom')), $reponses[2]);
		}
		
	function testOrdonneChamps()
		{
		$tab1=array(array('licence'=>'A', 'prenom'=>'cedric', 'moyenne'=>590), array('licence'=>'B', 'prenom'=>'gaston', 'moyenne'=>580), array('licence'=>'C', 'prenom'=>'bertrand', 'moyenne'=>570));
		$tab2=array(array('prenom'=>'cedric', 'licence'=>'A', 'moyenne'=>590), array('prenom'=>'gaston', 'licence'=>'B', 'moyenne'=>580), array('prenom'=>'bertrand', 'licence'=>'C', 'moyenne'=>570));

		$copie=$tab1;
		OrdonneChamps($tab1, array('licence', 'prenom', 'moyenne'));
		$this->assertEqual(true, CompareTableaux($tab1, $copie));
		OrdonneChamps($tab1, array('prenom', 'licence', 'moyenne'));
		$this->assertEqual(true, CompareTableaux($tab1, $tab2));
		}
		
	function testExportVersRat()
		{
		$champs=array('licence', 'position', 'france', 'cat', 'genre', 'arme', 'prenom', 'nom', 'agreement', 'club', 'score1', 'score2', 'score3', 'moyenne');
		
		$tab=array(
			array('licence'=>'C', 'nom'=>'labvue', 'prenom'=>'bertrand', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Paris'),
			array('licence'=>'F', 'nom'=>'tsuno', 'prenom'=>'yoko', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'F', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Tokyo'),
			array('licence'=>'B', 'nom'=>'lagaffe', 'prenom'=>'gaston', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Paris'),
			array('licence'=>'E', 'nom'=>'diaz', 'prenom'=>'cameron', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'F', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Houston'),
			array('licence'=>'A', 'nom'=>'girard', 'prenom'=>'cedric', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Donjon'),
			array('licence'=>'D', 'nom'=>'dechezsmith', 'prenom'=>'jules', 'score1'=>557, 'score2'=>556, 'score3'=>555, 'moyenne'=>0, 'arme'=>'CL', 'genre'=>'H', 'cat'=>'S', 'france'=>0, 'position'=>0, 'agreement'=>'C1', 'club'=>'Paris'));
		$reponses=array();
		$donnees=ExportVersRat($tab, $reponses);
		$this->assertEqual(
			'C$0$0$S$H$CL$bertrand$labvue$C1$Paris$557$556$555$0'."\r\n".
			'F$0$0$S$F$CL$yoko$tsuno$C1$Tokyo$557$556$555$0'."\r\n".
			'B$0$0$S$H$CL$gaston$lagaffe$C1$Paris$557$556$555$0'."\r\n".
			'E$0$0$S$F$CL$cameron$diaz$C1$Houston$557$556$555$0'."\r\n".
			'A$0$0$S$H$CL$cedric$girard$C1$Donjon$557$556$555$0'."\r\n".
			'D$0$0$S$H$CL$jules$dechezsmith$C1$Paris$557$556$555$0', $donnees);
		}
	}
	
?>